RMDIR(2)

NAME
rmdir - remove a directory file

SYNOPSIS
#include <unistd.h>
int
rmdir(const char *path);

DESCRIPTION
rmdir() removes a directory file whose name is given by path. The directory must not have any entries other than ‘’. and ‘..’.

There is no rmdirat() function; to remove a directory with a path relative to the directory associated with a file descriptor use the unlinkat(2) function with the AT_REMOVEDIR flag.

RETURN VALUES

ERRORS
The named file is removed unless:

[ENOTDIR]
    A component of the path is not a directory.

[ENAMETOOLONG]
    A component of a pathname exceeded NAME_MAX characters, or an entire pathname (including the terminating NUL) exceeded PATH_MAX bytes.

[ENOENT]
    The named directory does not exist.

[ELOOP]
    Too many symbolic links were encountered in translating the pathname.

[ENOTEMPTY]
    The named directory contains files other than ‘’. and ‘..’ in it.

[EACCES]
    Search permission is denied for a component of the path prefix.

[EACCES]
    Write permission is denied on the directory containing the directory to be removed.

[EPERM]
    The directory containing the directory to be removed is marked sticky, and neither the containing directory nor the directory to be removed are owned by the effective user ID.

[EPERM]
    The directory to be removed or the directory containing it has its immutable or append-only flag set (see chflags(2)).

[EBUSY]
    The directory to be removed is the mount point for a mounted file system.

[EINVAL]
    The last path element of the directory to be removed consists of ‘’..

[EIO]
    An I/O error occurred while deleting the directory entry or deallocating the inode.

[EROFS]
    The directory entry to be removed resides on a read-only file system.

[EFAULT]
    path points outside the process's allocated address space.

SEE ALSO
rmdir(1), chflags(2), mkdir(2), unlink(2)

STANDARDS
rmdir() function conforms to p1003.1-2008.

HISTORY
The rmdir() function call appeared in 4.1cBSD.